/*
 *  Eudyptula Challenge Task 01
 * */

/* This code is base on lkmpg */

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/proc_fs.h>	/* Necessary because we use the proc fs */
#include <linux/seq_file.h>
#include <linux/slab.h>

#include "license_pub.h"
#include "utils.h"

#define PROCFS_NAME "license"

#define DRIVER_AUTHOR "Wuhan Deepin Technology Co., Ltd. "
#define DRIVER_DESC   "License module of Deepin"

struct proc_dir_entry *License_Proc_File;

static int proc_show(struct seq_file *m, void *v)
{
    // char *buffer = NULL;
    // u64 size = 0;
    // if (!verify_licese_file(g_LicenseFile)) {
    //     seq_printf(m, "Deepin OS NOT Authorized !!!\nVerify Licese Failed\n");
    //     return 0;
    // }
    //
    // buffer = (char*)kmalloc(LICENSE_FILE_SIZE, GFP_KERNEL);
    // seq_printf(m, "Deepin OS is Authorized!!!\n");
    //
    // get_license_property(g_LicenseFile, UseName, buffer, &size);
    // seq_printf(m, "Authorized User:     %s\n", buffer);
    //
    // get_license_property(g_LicenseFile, Product, buffer, &size);
    // seq_printf(m, "OS version:          %s\n", buffer);
    //
    // get_license_property(g_LicenseFile, Edition, buffer, &size);
    // seq_printf(m, "Edition:             %s\n", buffer);
    //
    // get_license_property(g_LicenseFile, Commodity, buffer, &size);
    // seq_printf(m, "Commodity:           %s\n", buffer);
    //
    // get_license_property(g_LicenseFile, MachineCode, buffer, &size);
    // seq_printf(m, "MachineCode:         %s\n", buffer);
    //
    // get_license_property(g_LicenseFile, AuthorizeCode, buffer, &size);
    // seq_printf(m, "Authorizetion Code:  %s\n", buffer);
    //
    // kfree(buffer);

    return 0;
}

static int license_proc_open(struct inode *inode, struct  file *file)
{
    return single_open(file, proc_show, NULL);
}

static struct file_operations license_proc_ops = {
    .owner = THIS_MODULE,
    .open = license_proc_open,
    .read = seq_read,
    .llseek = seq_lseek,
    .release = single_release,
};

int init_module()
{
    lic_warning("Load Deepin License Verify Module\n");
    License_Proc_File = proc_create(PROCFS_NAME, 0644, NULL, &license_proc_ops);
    if (IS_ERR(License_Proc_File)) {
        lic_err(KERN_ALERT "could not initialize /proc/%s\n", PROCFS_NAME);
        return PTR_ERR(License_Proc_File);
    }
    lic_warning("/proc/%s created\n", PROCFS_NAME);

    return init_license_private();
}

void cleanup_module()
{
    remove_proc_entry(PROCFS_NAME, NULL);
    clean_license_private();

    lic_warning("/proc/%s removed\n", PROCFS_NAME);
    lic_warning("Unload Deepin License Verify Module\n\n");
}


MODULE_LICENSE("GPL");
MODULE_AUTHOR(DRIVER_AUTHOR);
MODULE_DESCRIPTION(DRIVER_DESC);
